class UserPolicy < ApplicationPolicy
  include FollowablePolicy
  include PublisherPolicy

  class Scope < PublisherPolicy::Scope; end

	def update?
    record if same_user? || authorized_user?
	end

  def create?
    authorized_user?
  end

  def show?
    record if user_exists?
  end

  def destroy?
    record if same_user? || user.is_admin?
  end

  def own_reviews?
    record if same_user? || user_can_moderate?
  end

  def received_reviews?
    record if same_user? || user_can_moderate?
  end

  def authorized_user?
    return false if ( record.is_admin? && !user.is_admin? )
    if ( record.is_moderator? )
      if !( same_user? || user.is_admin? )
        return false
      end
    end
    user_can_moderate?
  end

  def same_user?
    record == user
  end
end
